/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.streambase.services.webservicesclients;


import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.UniformInterfaceException;
import com.sun.jersey.api.client.WebResource;

/** Jersey REST client generated for REST resource:SetAndGetString [/helloWorld]<br>
 *  USAGE:<pre>
 *        JerseyClient1 client = new JerseyClient1();
 *        Object response = client.XXX(...);
 *        // do whatever with response
 *        client.close();
 *  </pre>
 * @author James Tomkinson
 */
public class JerseyClient1 {
    private WebResource webResource;
    private Client client;
    private String BASE_URI = "";
    
    /**
     * Constructor that sets up the web service at the specified URI
     * @param URI the service resource URL
     */
    public JerseyClient1(String URI) {
    	
    	// The URI to use
    	BASE_URI = URI;
    	
    	// Default configuration for the RESTful web service client.
        com.sun.jersey.api.client.config.ClientConfig config = new com.sun.jersey.api.client.config.DefaultClientConfig();
        
        // The Client class is the main configuration point for building a RESTful web service client. 
        // You use it to configure various client properties and features and indicate which resource providers to use.   
        client = Client.create(config);
        
        // To issue requests, one must create a WebResource object. This encapsulates a web resource for the client.
        // The following code creates a WebResource object for a web resource whose URI is BASE_URI 
        webResource = client.resource(BASE_URI);
    }

 
    /**
     * Set the string associated with a PUT request to a web resource     
     * @param requestEntity puts the text entity "requestEntity" into a web resource 
     * @throws UniformInterfaceException
     */
    public void setString(Object requestEntity) throws UniformInterfaceException {
        webResource.type(javax.ws.rs.core.MediaType.TEXT_PLAIN).put(requestEntity);
    }

    /**
     * Call the web service to get the XML string with the appropriate weather information
     * @param URI1 the service resource URL
     * @param zipcode the zip code 
     * @return an XML string with the weather information 
     * @throws UniformInterfaceException
     */
    public String getWeatherForZipCode(String URI1, String zipcode) throws UniformInterfaceException {
        URI1 += zipcode;
        WebResource resource = client.resource( URI1 );
        System.out.println("URI="+URI1);
        String cr = resource.accept(javax.ws.rs.core.MediaType.TEXT_HTML).get(String.class);
        return cr;
    }

    /**
     * Close the client connection
     */
    public void close() {
        client.destroy();
    }
    
}
